/*
 * Definitions of PALs
 */
#include <stdio.h>
#include "logsyn.h"
#include "pal.h"

extern struct pal *cur_pal;
extern char pol_bits[], ac_bits[];
extern char pal_ident[];

void pal_driver(), gala_driver(), galstd_driver(), v10_driver();
void pal_init(), pal_pin_decl(), do_jdc_pal();
void eqn_init(), eqn_pin_decl(), do_eqn_pal();

extern struct pal isp1016;

struct pal eqn = {
    0,	0,  0,  0,
    0,  0,  NULL,
    eqn_init, eqn_pin_decl, do_eqn_pal, NULL, 0
};

struct pin gal16_pins[] = {
    {GLOBAL_CLK},
    {INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {GND},
    {GLOBAL_OE},
    {IO_PIN|V8MACRO,	15,	56,	8,	7},
    {IO_PIN|V8MACRO,	13,	48,	8,	6},
    {IO_PIN|V8MACRO,	11,	40,	8,	5},
    {IO_PIN|V8MACRO,	9,	32,	8,	4},
    {IO_PIN|V8MACRO,	7,	24,	8,	3},
    {IO_PIN|V8MACRO,	5,	16,	8,	2},
    {IO_PIN|V8MACRO,	3,	8,	8,	1},
    {IO_PIN|V8MACRO,	1,	0,	8,	0},
    {VCC}
};

struct pin gal16comb_pins[] = {
    {INPUT_PIN,	1},
    {INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {GND},
    {INPUT_PIN,	15},
    {OUTPUT_PIN|V8MAC_COMB,	0,	56,	8,	7},
    {IO_PIN|V8MAC_COMB,	13,	48,	8,	6},
    {IO_PIN|V8MAC_COMB,	11,	40,	8,	5},
    {IO_PIN|V8MAC_COMB,	9,	32,	8,	4},
    {IO_PIN|V8MAC_COMB,	7,	24,	8,	3},
    {IO_PIN|V8MAC_COMB,	5,	16,	8,	2},
    {IO_PIN|V8MAC_COMB,	3,	8,	8,	1},
    {OUTPUT_PIN|V8MAC_COMB,	0,	0,	8,	0},
    {VCC}
};

struct pin gal20_pins[] = {
    {GLOBAL_CLK},
    {INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {INPUT_PIN,	16},
    {INPUT_PIN,	18},
    {GND},
    {GLOBAL_OE},
    {INPUT_PIN,	19},
    {IO_PIN|V8MACRO,	17,	56,	8,	7},
    {IO_PIN|V8MACRO,	15,	48,	8,	6},
    {IO_PIN|V8MACRO,	13,	40,	8,	5},
    {IO_PIN|V8MACRO,	11,	32,	8,	4},
    {IO_PIN|V8MACRO,	9,	24,	8,	3},
    {IO_PIN|V8MACRO,	7,	16,	8,	2},
    {IO_PIN|V8MACRO,	5,	8,	8,	1},
    {IO_PIN|V8MACRO,	3,	0,	8,	0},
    {INPUT_PIN,	1},
    {VCC}
};

struct pin gal20comb_pins[] = {
    {INPUT_PIN,	1},
    {INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {INPUT_PIN,	16},
    {INPUT_PIN,	18},
    {GND},
    {INPUT_PIN,	19},
    {INPUT_PIN,	17},
    {OUTPUT_PIN|V8MAC_COMB,	0,	56,	8,	7},
    {IO_PIN|V8MAC_COMB,	15,	48,	8,	6},
    {IO_PIN|V8MAC_COMB,	13,	40,	8,	5},
    {IO_PIN|V8MAC_COMB,	11,	32,	8,	4},
    {IO_PIN|V8MAC_COMB,	9,	24,	8,	3},
    {IO_PIN|V8MAC_COMB,	7,	16,	8,	2},
    {IO_PIN|V8MAC_COMB,	5,	8,	8,	1},
    {OUTPUT_PIN|V8MAC_COMB,	0,	0,	8,	0},
    {INPUT_PIN,	3},
    {VCC}
};

struct pal gal16v8a = {
    20,	8,	16,	64,
    1,	11,	gal16_pins,
    pal_init, pal_pin_decl, do_jdc_pal, gala_driver, 0
};

struct pal gal16v8a_comb = {
    20,	8,	16,	64,
    0,	0,	gal16comb_pins,
    pal_init, pal_pin_decl, do_jdc_pal, gala_driver, 1
};

struct pal gal20v8a = {
    24,	8,	20,	64,
    1,	13,	gal20_pins,
    pal_init, pal_pin_decl, do_jdc_pal, gala_driver, 0
};

struct pal gal20v8a_comb = {
    24,	8,	20,	64,
    0,	0,	gal20comb_pins,
    pal_init, pal_pin_decl, do_jdc_pal, gala_driver, 1
};

struct pal gal16v8std = {
    20,	8,	16,	64,
    1,	11,	gal16_pins,
    pal_init, pal_pin_decl, do_jdc_pal, galstd_driver, 0
};

struct pal gal16v8std_comb = {
    20,	8,	16,	64,
    0,	0,	gal16comb_pins,
    pal_init, pal_pin_decl, do_jdc_pal, galstd_driver, 1
};

struct pal gal20v8std = {
    24,	8,	20,	64,
    1,	13,	gal20_pins,
    pal_init, pal_pin_decl, do_jdc_pal, galstd_driver, 0
};

struct pal gal20v8std_comb = {
    24,	8,	20,	64,
    0,	0,	gal20comb_pins,
    pal_init, pal_pin_decl, do_jdc_pal, galstd_driver, 1
};

struct pin pal16l8_pins[] = {
    {INPUT_PIN,	1},
    {INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {GND},
    {INPUT_PIN,	15},
    {OUTPUT_PIN|POL_LOW|COMB,	0,	56,	8,	7},
    {IO_PIN|POL_LOW|COMB,		13,	48,	8,	6},
    {IO_PIN|POL_LOW|COMB,		11,	40,	8,	5},
    {IO_PIN|POL_LOW|COMB,		9,	32,	8,	4},
    {IO_PIN|POL_LOW|COMB,		7,	24,	8,	3},
    {IO_PIN|POL_LOW|COMB,		5,	16,	8,	2},
    {IO_PIN|POL_LOW|COMB,		3,	8,	8,	1},
    {OUTPUT_PIN|POL_LOW|COMB,	0,	0,	8,	0},
    {VCC}
};

struct pal pal16l8 = {
    20,	8,	16,	64,
    0,	0,	pal16l8_pins,
    pal_init, pal_pin_decl, do_jdc_pal, pal_driver, 0
};

struct pin pal16r4_pins[] = {
    {GLOBAL_CLK},
    {INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {GND},
    {GLOBAL_OE},
    {IO_PIN|POL_LOW|COMB,	15,	56,	8,	7},
    {IO_PIN|POL_LOW|COMB,	13,	48,	8,	6},
    {IO_PIN|POL_LOW|REG,	11,	40,	8,	5},
    {IO_PIN|POL_LOW|REG,	9,	32,	8,	4},
    {IO_PIN|POL_LOW|REG,	7,	24,	8,	3},
    {IO_PIN|POL_LOW|REG,	5,	16,	8,	2},
    {IO_PIN|POL_LOW|COMB,	3,	8,	8,	1},
    {IO_PIN|POL_LOW|COMB,	1,	0,	8,	0},
    {VCC}
};

struct pal pal16r4 = {
    20,	8,	16,	64,
    1,	11,	pal16r4_pins,
    pal_init, pal_pin_decl, do_jdc_pal, pal_driver, 0
};

struct pin pal16r6_pins[] = {
    {GLOBAL_CLK},
    {INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {GND},
    {GLOBAL_OE},
    {IO_PIN|POL_LOW|COMB,	15,	56,	8,	7},
    {IO_PIN|POL_LOW|REG,	13,	48,	8,	6},
    {IO_PIN|POL_LOW|REG,	11,	40,	8,	5},
    {IO_PIN|POL_LOW|REG,	9,	32,	8,	4},
    {IO_PIN|POL_LOW|REG,	7,	24,	8,	3},
    {IO_PIN|POL_LOW|REG,	5,	16,	8,	2},
    {IO_PIN|POL_LOW|REG,	3,	8,	8,	1},
    {IO_PIN|POL_LOW|COMB,	1,	0,	8,	0},
    {VCC}
};

struct pal pal16r6 = {
    20,	8,	16,	64,
    1,	11,	pal16r6_pins,
    pal_init, pal_pin_decl, do_jdc_pal, pal_driver, 0
};

struct pin pal16r8_pins[] = {
    {GLOBAL_CLK},
    {INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {GND},
    {GLOBAL_OE},
    {IO_PIN|POL_LOW|REG,	15,	56,	8,	7},
    {IO_PIN|POL_LOW|REG,	13,	48,	8,	6},
    {IO_PIN|POL_LOW|REG,	11,	40,	8,	5},
    {IO_PIN|POL_LOW|REG,	9,	32,	8,	4},
    {IO_PIN|POL_LOW|REG,	7,	24,	8,	3},
    {IO_PIN|POL_LOW|REG,	5,	16,	8,	2},
    {IO_PIN|POL_LOW|REG,	3,	8,	8,	1},
    {IO_PIN|POL_LOW|REG,	1,	0,	8,	0},
    {VCC}
};

struct pal pal16r8 = {
    20,	8,	16,	64,
    1,	11,	pal16r8_pins,
    pal_init, pal_pin_decl, do_jdc_pal, pal_driver, 0
};

struct pin pal20l8_pins[] = {
    {INPUT_PIN,	1},
    {INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {INPUT_PIN,	16},
    {INPUT_PIN,	18},
    {GND},
    {INPUT_PIN,	19},
    {INPUT_PIN,	17},
    {OUTPUT_PIN|POL_LOW|COMB,	0,	56,	8,	7},
    {IO_PIN|POL_LOW|COMB,		15,	48,	8,	6},
    {IO_PIN|POL_LOW|COMB,		13,	40,	8,	5},
    {IO_PIN|POL_LOW|COMB,		11,	32,	8,	4},
    {IO_PIN|POL_LOW|COMB,		9,	24,	8,	3},
    {IO_PIN|POL_LOW|COMB,		7,	16,	8,	2},
    {IO_PIN|POL_LOW|COMB,		5,	8,	8,	1},
    {OUTPUT_PIN|POL_LOW|COMB,	0,	0,	8,	0},
    {INPUT_PIN,	3},
    {VCC}
};

struct pal pal20l8 = {
    24,	8,	20,	64,
    0,	0,	pal20l8_pins,
    pal_init, pal_pin_decl, do_jdc_pal, pal_driver, 0
};

struct pin pal20r4_pins[] = {
    {GLOBAL_CLK},
    {INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {INPUT_PIN,	16},
    {INPUT_PIN,	18},
    {GND},
    {GLOBAL_OE},
    {INPUT_PIN,	19},
    {IO_PIN|POL_LOW|COMB,	17,	56,	8,	7},
    {IO_PIN|POL_LOW|COMB,	15,	48,	8,	6},
    {IO_PIN|POL_LOW|REG,	13,	40,	8,	5},
    {IO_PIN|POL_LOW|REG,	11,	32,	8,	4},
    {IO_PIN|POL_LOW|REG,	9,	24,	8,	3},
    {IO_PIN|POL_LOW|REG,	7,	16,	8,	2},
    {IO_PIN|POL_LOW|COMB,	5,	8,	8,	1},
    {IO_PIN|POL_LOW|COMB,	3,	0,	8,	0},
    {INPUT_PIN,	1},
    {VCC}
};

struct pal pal20r4 = {
    24,	8,	20,	64,
    1,	13,	pal20r4_pins,
    pal_init, pal_pin_decl, do_jdc_pal, pal_driver, 0
};

struct pin pal20r6_pins[] = {
    {GLOBAL_CLK},
    {INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {INPUT_PIN,	16},
    {INPUT_PIN,	18},
    {GND},
    {GLOBAL_OE},
    {INPUT_PIN,	19},
    {IO_PIN|POL_LOW|COMB,	17,	56,	8,	7},
    {IO_PIN|POL_LOW|REG,	15,	48,	8,	6},
    {IO_PIN|POL_LOW|REG,	13,	40,	8,	5},
    {IO_PIN|POL_LOW|REG,	11,	32,	8,	4},
    {IO_PIN|POL_LOW|REG,	9,	24,	8,	3},
    {IO_PIN|POL_LOW|REG,	7,	16,	8,	2},
    {IO_PIN|POL_LOW|REG,	5,	8,	8,	1},
    {IO_PIN|POL_LOW|COMB,	3,	0,	8,	0},
    {INPUT_PIN,	1},
    {VCC}
};

struct pal pal20r6 = {
    24,	8,	20,	64,
    1,	13,	pal20r6_pins,
    pal_init, pal_pin_decl, do_jdc_pal, pal_driver, 0
};

struct pin pal20r8_pins[] = {
    {GLOBAL_CLK},
    {INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {INPUT_PIN,	16},
    {INPUT_PIN,	18},
    {GND},
    {GLOBAL_OE},
    {INPUT_PIN,	19},
    {IO_PIN|POL_LOW|REG,	17,	56,	8,	7},
    {IO_PIN|POL_LOW|REG,	15,	48,	8,	6},
    {IO_PIN|POL_LOW|REG,	13,	40,	8,	5},
    {IO_PIN|POL_LOW|REG,	11,	32,	8,	4},
    {IO_PIN|POL_LOW|REG,	9,	24,	8,	3},
    {IO_PIN|POL_LOW|REG,	7,	16,	8,	2},
    {IO_PIN|POL_LOW|REG,	5,	8,	8,	1},
    {IO_PIN|POL_LOW|REG,	3,	0,	8,	0},
    {INPUT_PIN,	1},
    {VCC}
};

struct pal pal20r8 = {
    24,	8,	20,	64,
    1,	13,	pal20r8_pins,
    pal_init, pal_pin_decl, do_jdc_pal, pal_driver, 0
};

struct pin pal22v10_pins[] = {
    {GLOBAL_CLK|INPUT_PIN,	0},
    {INPUT_PIN,	2},
    {INPUT_PIN,	4},
    {INPUT_PIN,	6},
    {INPUT_PIN,	8},
    {INPUT_PIN,	10},
    {INPUT_PIN,	12},
    {INPUT_PIN,	14},
    {INPUT_PIN,	16},
    {INPUT_PIN,	18},
    {INPUT_PIN,	20},
    {GND},
    {INPUT_PIN,	21},
    {IO_PIN|V10MACRO,	19,	122,	9,	9},
    {IO_PIN|V10MACRO,	17,	111,	11,	8},
    {IO_PIN|V10MACRO,	15,	98,	13,	7},
    {IO_PIN|V10MACRO,	13,	83,	15,	6},
    {IO_PIN|V10MACRO,	11,	66,	17,	5},
    {IO_PIN|V10MACRO,	9,	49,	17,	4},
    {IO_PIN|V10MACRO,	7,	34,	15,	3},
    {IO_PIN|V10MACRO,	5,	21,	13,	2},
    {IO_PIN|V10MACRO,	3,	10,	11,	1},
    {IO_PIN|V10MACRO,	1,	1,	9,	0},
    {VCC}
};

struct pal pal22v10 = {
    24,	10,	22,	132,
    1,	0,	pal22v10_pins,
    pal_init, pal_pin_decl, do_jdc_pal, v10_driver, 0
};

struct pal_tbl pal_table[] = {
    "equations",	&eqn,
    "isp1016",		&isp1016,
    "gal16v8a",		&gal16v8a,
    "gal16v8a-comb",	&gal16v8a_comb,
    "gal20v8a",		&gal20v8a,
    "gal20v8a-comb",	&gal20v8a_comb,
    "gal16v8",		&gal16v8std,
    "gal16v8-comb",	&gal16v8std_comb,
    "gal20v8",		&gal20v8std,
    "gal20v8-comb",	&gal20v8std_comb,
    "pal16l8",		&pal16l8,
    "pal16r4",		&pal16r4,
    "pal16r6",		&pal16r6,
    "pal16r8",		&pal16r8,
    "pal20l8",		&pal20l8,
    "pal20r4",		&pal20r4,
    "pal20r6",		&pal20r6,
    "pal20r8",		&pal20r8,
    "22v10",		&pal22v10,
    NULL,		NULL
};

/* No architecture bits for PALs */
void
pal_driver()
{
}

/* Output architecture and polarity bits for a 22V10 */
void
v10_driver()
{
	register int ja, i;

	ja = cur_pal->num_cols * cur_pal->num_rows * 2;
	jdc_addr(ja);
	for( i = 0; i < cur_pal->num_outputs; ++i ){
		jdc_const(pol_bits[i], 1);
		jdc_const(ac_bits[i], 1);
	}
	jdc_newline();
}

/* Output architecture and polarity bits for standard GALs */
void
galstd_driver(syn)
int syn;
{
	register int ja, i, j, c;

	ja = cur_pal->num_cols * cur_pal->num_rows * 2;
	jdc_addr(ja);
	jdc_bits(pol_bits, 8);			/* polarity */
	for( i = 7; i >= 0; --i ){		/* output ident string */
		c = pal_ident[i];
		for( j = 7; j >= 0; --j ){
			jdc_const(c & 1, 1);
			c >>= 1;
		}
	}
	jdc_newline();
	jdc_bits(ac_bits, 8);		/* AC1<19:12> or AC1<21:18> */
	jdc_const(1, 64);
	jdc_const(syn, 1);		/* SYN */
	jdc_const(1, 1);		/* AC0 */
	jdc_newline();
}

/* Output architecture and polarity bits for GAL (A-series) */
void
gala_driver(syn)
int syn;
{
	register int ja, i, j, c;

	ja = cur_pal->num_cols * cur_pal->num_rows * 2;
	jdc_true(ja, 8);			/* "polarity" */
	for( i = 7; i >= 0; --i ){		/* output ident string */
		c = pal_ident[i];
		for( j = 7; j >= 0; --j ){
			jdc_const(c & 1, 1);
			c >>= 1;
		}
	}
	jdc_newline();
	jdc_const(1, 8);
	jdc_bits(pol_bits, 4);		/* XOR[19:16] or XOR[21:18] */
	jdc_const(1, 1);		/* AC0 */
	jdc_bits(ac_bits, 4);		/* AC1[19:16] or AC1[21:18] */
	jdc_const(1, 46);
	jdc_bits(ac_bits+4, 4);		/* AC1[15:12] or AC1[17:14] */
	jdc_const(syn, 1);		/* SYN */
	jdc_bits(pol_bits+4, 4);	/* XOR[15:12] or XOR[17:14] */
	jdc_const(1, 2);
	jdc_newline();
}
